<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - report.info - /usr/include/c++/9/bits/atomic_base.h</title>
  <link rel="stylesheet" type="text/css" href="../../../../../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../../../../../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../../../../../index.html">top level</a> - <a href="index.html">usr/include/c++/9/bits</a> - atomic_base.h<span style="font-size: 80%;"> (source / <a href="atomic_base.h.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">report.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">9</td>
            <td class="headerCovTableEntry">9</td>
            <td class="headerCovTableEntryHi">100.0 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2021-03-29 02:25:54</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">4</td>
            <td class="headerCovTableEntry">4</td>
            <td class="headerCovTableEntryHi">100.0 %</td>
          </tr>
          <tr><td><img src="../../../../../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../../../../../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span>            : // -*- C++ -*- header.</a>
<a name="2"><span class="lineNum">       2 </span>            : </a>
<a name="3"><span class="lineNum">       3 </span>            : // Copyright (C) 2008-2019 Free Software Foundation, Inc.</a>
<a name="4"><span class="lineNum">       4 </span>            : //</a>
<a name="5"><span class="lineNum">       5 </span>            : // This file is part of the GNU ISO C++ Library.  This library is free</a>
<a name="6"><span class="lineNum">       6 </span>            : // software; you can redistribute it and/or modify it under the</a>
<a name="7"><span class="lineNum">       7 </span>            : // terms of the GNU General Public License as published by the</a>
<a name="8"><span class="lineNum">       8 </span>            : // Free Software Foundation; either version 3, or (at your option)</a>
<a name="9"><span class="lineNum">       9 </span>            : // any later version.</a>
<a name="10"><span class="lineNum">      10 </span>            : </a>
<a name="11"><span class="lineNum">      11 </span>            : // This library is distributed in the hope that it will be useful,</a>
<a name="12"><span class="lineNum">      12 </span>            : // but WITHOUT ANY WARRANTY; without even the implied warranty of</a>
<a name="13"><span class="lineNum">      13 </span>            : // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</a>
<a name="14"><span class="lineNum">      14 </span>            : // GNU General Public License for more details.</a>
<a name="15"><span class="lineNum">      15 </span>            : </a>
<a name="16"><span class="lineNum">      16 </span>            : // Under Section 7 of GPL version 3, you are granted additional</a>
<a name="17"><span class="lineNum">      17 </span>            : // permissions described in the GCC Runtime Library Exception, version</a>
<a name="18"><span class="lineNum">      18 </span>            : // 3.1, as published by the Free Software Foundation.</a>
<a name="19"><span class="lineNum">      19 </span>            : </a>
<a name="20"><span class="lineNum">      20 </span>            : // You should have received a copy of the GNU General Public License and</a>
<a name="21"><span class="lineNum">      21 </span>            : // a copy of the GCC Runtime Library Exception along with this program;</a>
<a name="22"><span class="lineNum">      22 </span>            : // see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see</a>
<a name="23"><span class="lineNum">      23 </span>            : // &lt;http://www.gnu.org/licenses/&gt;.</a>
<a name="24"><span class="lineNum">      24 </span>            : </a>
<a name="25"><span class="lineNum">      25 </span>            : /** @file bits/atomic_base.h</a>
<a name="26"><span class="lineNum">      26 </span>            :  *  This is an internal header file, included by other library headers.</a>
<a name="27"><span class="lineNum">      27 </span>            :  *  Do not attempt to use it directly. @headername{atomic}</a>
<a name="28"><span class="lineNum">      28 </span>            :  */</a>
<a name="29"><span class="lineNum">      29 </span>            : </a>
<a name="30"><span class="lineNum">      30 </span>            : #ifndef _GLIBCXX_ATOMIC_BASE_H</a>
<a name="31"><span class="lineNum">      31 </span>            : #define _GLIBCXX_ATOMIC_BASE_H 1</a>
<a name="32"><span class="lineNum">      32 </span>            : </a>
<a name="33"><span class="lineNum">      33 </span>            : #pragma GCC system_header</a>
<a name="34"><span class="lineNum">      34 </span>            : </a>
<a name="35"><span class="lineNum">      35 </span>            : #include &lt;bits/c++config.h&gt;</a>
<a name="36"><span class="lineNum">      36 </span>            : #include &lt;stdint.h&gt;</a>
<a name="37"><span class="lineNum">      37 </span>            : #include &lt;bits/atomic_lockfree_defines.h&gt;</a>
<a name="38"><span class="lineNum">      38 </span>            : </a>
<a name="39"><span class="lineNum">      39 </span>            : #ifndef _GLIBCXX_ALWAYS_INLINE</a>
<a name="40"><span class="lineNum">      40 </span>            : #define _GLIBCXX_ALWAYS_INLINE inline __attribute__((__always_inline__))</a>
<a name="41"><span class="lineNum">      41 </span>            : #endif</a>
<a name="42"><span class="lineNum">      42 </span>            : </a>
<a name="43"><span class="lineNum">      43 </span>            : namespace std _GLIBCXX_VISIBILITY(default)</a>
<a name="44"><span class="lineNum">      44 </span>            : {</a>
<a name="45"><span class="lineNum">      45 </span>            : _GLIBCXX_BEGIN_NAMESPACE_VERSION</a>
<a name="46"><span class="lineNum">      46 </span>            : </a>
<a name="47"><span class="lineNum">      47 </span>            :   /**</a>
<a name="48"><span class="lineNum">      48 </span>            :    * @defgroup atomics Atomics</a>
<a name="49"><span class="lineNum">      49 </span>            :    *</a>
<a name="50"><span class="lineNum">      50 </span>            :    * Components for performing atomic operations.</a>
<a name="51"><span class="lineNum">      51 </span>            :    * @{</a>
<a name="52"><span class="lineNum">      52 </span>            :    */</a>
<a name="53"><span class="lineNum">      53 </span>            : </a>
<a name="54"><span class="lineNum">      54 </span>            :   /// Enumeration for memory_order</a>
<a name="55"><span class="lineNum">      55 </span>            : #if __cplusplus &gt; 201703L</a>
<a name="56"><span class="lineNum">      56 </span>            :   enum class memory_order : int</a>
<a name="57"><span class="lineNum">      57 </span>            :     {</a>
<a name="58"><span class="lineNum">      58 </span>            :       relaxed,</a>
<a name="59"><span class="lineNum">      59 </span>            :       consume,</a>
<a name="60"><span class="lineNum">      60 </span>            :       acquire,</a>
<a name="61"><span class="lineNum">      61 </span>            :       release,</a>
<a name="62"><span class="lineNum">      62 </span>            :       acq_rel,</a>
<a name="63"><span class="lineNum">      63 </span>            :       seq_cst</a>
<a name="64"><span class="lineNum">      64 </span>            :     };</a>
<a name="65"><span class="lineNum">      65 </span>            : </a>
<a name="66"><span class="lineNum">      66 </span>            :   inline constexpr memory_order memory_order_relaxed = memory_order::relaxed;</a>
<a name="67"><span class="lineNum">      67 </span>            :   inline constexpr memory_order memory_order_consume = memory_order::consume;</a>
<a name="68"><span class="lineNum">      68 </span>            :   inline constexpr memory_order memory_order_acquire = memory_order::acquire;</a>
<a name="69"><span class="lineNum">      69 </span>            :   inline constexpr memory_order memory_order_release = memory_order::release;</a>
<a name="70"><span class="lineNum">      70 </span>            :   inline constexpr memory_order memory_order_acq_rel = memory_order::acq_rel;</a>
<a name="71"><span class="lineNum">      71 </span>            :   inline constexpr memory_order memory_order_seq_cst = memory_order::seq_cst;</a>
<a name="72"><span class="lineNum">      72 </span>            : #else</a>
<a name="73"><span class="lineNum">      73 </span>            :   typedef enum memory_order</a>
<a name="74"><span class="lineNum">      74 </span>            :     {</a>
<a name="75"><span class="lineNum">      75 </span>            :       memory_order_relaxed,</a>
<a name="76"><span class="lineNum">      76 </span>            :       memory_order_consume,</a>
<a name="77"><span class="lineNum">      77 </span>            :       memory_order_acquire,</a>
<a name="78"><span class="lineNum">      78 </span>            :       memory_order_release,</a>
<a name="79"><span class="lineNum">      79 </span>            :       memory_order_acq_rel,</a>
<a name="80"><span class="lineNum">      80 </span>            :       memory_order_seq_cst</a>
<a name="81"><span class="lineNum">      81 </span>            :     } memory_order;</a>
<a name="82"><span class="lineNum">      82 </span>            : #endif</a>
<a name="83"><span class="lineNum">      83 </span>            : </a>
<a name="84"><span class="lineNum">      84 </span>            :   enum __memory_order_modifier</a>
<a name="85"><span class="lineNum">      85 </span>            :     {</a>
<a name="86"><span class="lineNum">      86 </span>            :       __memory_order_mask          = 0x0ffff,</a>
<a name="87"><span class="lineNum">      87 </span>            :       __memory_order_modifier_mask = 0xffff0000,</a>
<a name="88"><span class="lineNum">      88 </span>            :       __memory_order_hle_acquire   = 0x10000,</a>
<a name="89"><span class="lineNum">      89 </span>            :       __memory_order_hle_release   = 0x20000</a>
<a name="90"><span class="lineNum">      90 </span>            :     };</a>
<a name="91"><span class="lineNum">      91 </span>            : </a>
<a name="92"><span class="lineNum">      92 </span>            :   constexpr memory_order</a>
<a name="93"><span class="lineNum">      93 </span>            :   operator|(memory_order __m, __memory_order_modifier __mod)</a>
<a name="94"><span class="lineNum">      94 </span>            :   {</a>
<a name="95"><span class="lineNum">      95 </span>            :     return memory_order(int(__m) | int(__mod));</a>
<a name="96"><span class="lineNum">      96 </span>            :   }</a>
<a name="97"><span class="lineNum">      97 </span>            : </a>
<a name="98"><span class="lineNum">      98 </span>            :   constexpr memory_order</a>
<a name="99"><span class="lineNum">      99 </span><span class="lineCov">      74176 :   operator&amp;(memory_order __m, __memory_order_modifier __mod)</span></a>
<a name="100"><span class="lineNum">     100 </span>            :   {</a>
<a name="101"><span class="lineNum">     101 </span><span class="lineCov">      74176 :     return memory_order(int(__m) &amp; int(__mod));</span></a>
<a name="102"><span class="lineNum">     102 </span>            :   }</a>
<a name="103"><span class="lineNum">     103 </span>            : </a>
<a name="104"><span class="lineNum">     104 </span>            :   // Drop release ordering as per [atomics.types.operations.req]/21</a>
<a name="105"><span class="lineNum">     105 </span>            :   constexpr memory_order</a>
<a name="106"><span class="lineNum">     106 </span>            :   __cmpexch_failure_order2(memory_order __m) noexcept</a>
<a name="107"><span class="lineNum">     107 </span>            :   {</a>
<a name="108"><span class="lineNum">     108 </span>            :     return __m == memory_order_acq_rel ? memory_order_acquire</a>
<a name="109"><span class="lineNum">     109 </span>            :       : __m == memory_order_release ? memory_order_relaxed : __m;</a>
<a name="110"><span class="lineNum">     110 </span>            :   }</a>
<a name="111"><span class="lineNum">     111 </span>            : </a>
<a name="112"><span class="lineNum">     112 </span>            :   constexpr memory_order</a>
<a name="113"><span class="lineNum">     113 </span>            :   __cmpexch_failure_order(memory_order __m) noexcept</a>
<a name="114"><span class="lineNum">     114 </span>            :   {</a>
<a name="115"><span class="lineNum">     115 </span>            :     return memory_order(__cmpexch_failure_order2(__m &amp; __memory_order_mask)</a>
<a name="116"><span class="lineNum">     116 </span>            :       | __memory_order_modifier(__m &amp; __memory_order_modifier_mask));</a>
<a name="117"><span class="lineNum">     117 </span>            :   }</a>
<a name="118"><span class="lineNum">     118 </span>            : </a>
<a name="119"><span class="lineNum">     119 </span>            :   _GLIBCXX_ALWAYS_INLINE void</a>
<a name="120"><span class="lineNum">     120 </span>            :   atomic_thread_fence(memory_order __m) noexcept</a>
<a name="121"><span class="lineNum">     121 </span>            :   { __atomic_thread_fence(int(__m)); }</a>
<a name="122"><span class="lineNum">     122 </span>            : </a>
<a name="123"><span class="lineNum">     123 </span>            :   _GLIBCXX_ALWAYS_INLINE void</a>
<a name="124"><span class="lineNum">     124 </span>            :   atomic_signal_fence(memory_order __m) noexcept</a>
<a name="125"><span class="lineNum">     125 </span>            :   { __atomic_signal_fence(int(__m)); }</a>
<a name="126"><span class="lineNum">     126 </span>            : </a>
<a name="127"><span class="lineNum">     127 </span>            :   /// kill_dependency</a>
<a name="128"><span class="lineNum">     128 </span>            :   template&lt;typename _Tp&gt;</a>
<a name="129"><span class="lineNum">     129 </span>            :     inline _Tp</a>
<a name="130"><span class="lineNum">     130 </span>            :     kill_dependency(_Tp __y) noexcept</a>
<a name="131"><span class="lineNum">     131 </span>            :     {</a>
<a name="132"><span class="lineNum">     132 </span>            :       _Tp __ret(__y);</a>
<a name="133"><span class="lineNum">     133 </span>            :       return __ret;</a>
<a name="134"><span class="lineNum">     134 </span>            :     }</a>
<a name="135"><span class="lineNum">     135 </span>            : </a>
<a name="136"><span class="lineNum">     136 </span>            : </a>
<a name="137"><span class="lineNum">     137 </span>            :   // Base types for atomics.</a>
<a name="138"><span class="lineNum">     138 </span>            :   template&lt;typename _IntTp&gt;</a>
<a name="139"><span class="lineNum">     139 </span>            :     struct __atomic_base;</a>
<a name="140"><span class="lineNum">     140 </span>            : </a>
<a name="141"><span class="lineNum">     141 </span>            : </a>
<a name="142"><span class="lineNum">     142 </span>            : #define ATOMIC_VAR_INIT(_VI) { _VI }</a>
<a name="143"><span class="lineNum">     143 </span>            : </a>
<a name="144"><span class="lineNum">     144 </span>            :   template&lt;typename _Tp&gt;</a>
<a name="145"><span class="lineNum">     145 </span>            :     struct atomic;</a>
<a name="146"><span class="lineNum">     146 </span>            : </a>
<a name="147"><span class="lineNum">     147 </span>            :   template&lt;typename _Tp&gt;</a>
<a name="148"><span class="lineNum">     148 </span>            :     struct atomic&lt;_Tp*&gt;;</a>
<a name="149"><span class="lineNum">     149 </span>            : </a>
<a name="150"><span class="lineNum">     150 </span>            :     /* The target's &quot;set&quot; value for test-and-set may not be exactly 1.  */</a>
<a name="151"><span class="lineNum">     151 </span>            : #if __GCC_ATOMIC_TEST_AND_SET_TRUEVAL == 1</a>
<a name="152"><span class="lineNum">     152 </span>            :     typedef bool __atomic_flag_data_type;</a>
<a name="153"><span class="lineNum">     153 </span>            : #else</a>
<a name="154"><span class="lineNum">     154 </span>            :     typedef unsigned char __atomic_flag_data_type;</a>
<a name="155"><span class="lineNum">     155 </span>            : #endif</a>
<a name="156"><span class="lineNum">     156 </span>            : </a>
<a name="157"><span class="lineNum">     157 </span>            :   /**</a>
<a name="158"><span class="lineNum">     158 </span>            :    *  @brief Base type for atomic_flag.</a>
<a name="159"><span class="lineNum">     159 </span>            :    *</a>
<a name="160"><span class="lineNum">     160 </span>            :    *  Base type is POD with data, allowing atomic_flag to derive from</a>
<a name="161"><span class="lineNum">     161 </span>            :    *  it and meet the standard layout type requirement. In addition to</a>
<a name="162"><span class="lineNum">     162 </span>            :    *  compatibility with a C interface, this allows different</a>
<a name="163"><span class="lineNum">     163 </span>            :    *  implementations of atomic_flag to use the same atomic operation</a>
<a name="164"><span class="lineNum">     164 </span>            :    *  functions, via a standard conversion to the __atomic_flag_base</a>
<a name="165"><span class="lineNum">     165 </span>            :    *  argument.</a>
<a name="166"><span class="lineNum">     166 </span>            :   */</a>
<a name="167"><span class="lineNum">     167 </span>            :   _GLIBCXX_BEGIN_EXTERN_C</a>
<a name="168"><span class="lineNum">     168 </span>            : </a>
<a name="169"><span class="lineNum">     169 </span>            :   struct __atomic_flag_base</a>
<a name="170"><span class="lineNum">     170 </span>            :   {</a>
<a name="171"><span class="lineNum">     171 </span>            :     __atomic_flag_data_type _M_i;</a>
<a name="172"><span class="lineNum">     172 </span>            :   };</a>
<a name="173"><span class="lineNum">     173 </span>            : </a>
<a name="174"><span class="lineNum">     174 </span>            :   _GLIBCXX_END_EXTERN_C</a>
<a name="175"><span class="lineNum">     175 </span>            : </a>
<a name="176"><span class="lineNum">     176 </span>            : #define ATOMIC_FLAG_INIT { 0 }</a>
<a name="177"><span class="lineNum">     177 </span>            : </a>
<a name="178"><span class="lineNum">     178 </span>            :   /// atomic_flag</a>
<a name="179"><span class="lineNum">     179 </span>            :   struct atomic_flag : public __atomic_flag_base</a>
<a name="180"><span class="lineNum">     180 </span>            :   {</a>
<a name="181"><span class="lineNum">     181 </span>            :     atomic_flag() noexcept = default;</a>
<a name="182"><span class="lineNum">     182 </span>            :     ~atomic_flag() noexcept = default;</a>
<a name="183"><span class="lineNum">     183 </span>            :     atomic_flag(const atomic_flag&amp;) = delete;</a>
<a name="184"><span class="lineNum">     184 </span>            :     atomic_flag&amp; operator=(const atomic_flag&amp;) = delete;</a>
<a name="185"><span class="lineNum">     185 </span>            :     atomic_flag&amp; operator=(const atomic_flag&amp;) volatile = delete;</a>
<a name="186"><span class="lineNum">     186 </span>            : </a>
<a name="187"><span class="lineNum">     187 </span>            :     // Conversion to ATOMIC_FLAG_INIT.</a>
<a name="188"><span class="lineNum">     188 </span>            :     constexpr atomic_flag(bool __i) noexcept</a>
<a name="189"><span class="lineNum">     189 </span>            :       : __atomic_flag_base{ _S_init(__i) }</a>
<a name="190"><span class="lineNum">     190 </span>            :     { }</a>
<a name="191"><span class="lineNum">     191 </span>            : </a>
<a name="192"><span class="lineNum">     192 </span>            :     _GLIBCXX_ALWAYS_INLINE bool</a>
<a name="193"><span class="lineNum">     193 </span>            :     test_and_set(memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="194"><span class="lineNum">     194 </span>            :     {</a>
<a name="195"><span class="lineNum">     195 </span>            :       return __atomic_test_and_set (&amp;_M_i, int(__m));</a>
<a name="196"><span class="lineNum">     196 </span>            :     }</a>
<a name="197"><span class="lineNum">     197 </span>            : </a>
<a name="198"><span class="lineNum">     198 </span>            :     _GLIBCXX_ALWAYS_INLINE bool</a>
<a name="199"><span class="lineNum">     199 </span>            :     test_and_set(memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="200"><span class="lineNum">     200 </span>            :     {</a>
<a name="201"><span class="lineNum">     201 </span>            :       return __atomic_test_and_set (&amp;_M_i, int(__m));</a>
<a name="202"><span class="lineNum">     202 </span>            :     }</a>
<a name="203"><span class="lineNum">     203 </span>            : </a>
<a name="204"><span class="lineNum">     204 </span>            :     _GLIBCXX_ALWAYS_INLINE void</a>
<a name="205"><span class="lineNum">     205 </span>            :     clear(memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="206"><span class="lineNum">     206 </span>            :     {</a>
<a name="207"><span class="lineNum">     207 </span>            :       memory_order __b = __m &amp; __memory_order_mask;</a>
<a name="208"><span class="lineNum">     208 </span>            :       __glibcxx_assert(__b != memory_order_consume);</a>
<a name="209"><span class="lineNum">     209 </span>            :       __glibcxx_assert(__b != memory_order_acquire);</a>
<a name="210"><span class="lineNum">     210 </span>            :       __glibcxx_assert(__b != memory_order_acq_rel);</a>
<a name="211"><span class="lineNum">     211 </span>            : </a>
<a name="212"><span class="lineNum">     212 </span>            :       __atomic_clear (&amp;_M_i, int(__m));</a>
<a name="213"><span class="lineNum">     213 </span>            :     }</a>
<a name="214"><span class="lineNum">     214 </span>            : </a>
<a name="215"><span class="lineNum">     215 </span>            :     _GLIBCXX_ALWAYS_INLINE void</a>
<a name="216"><span class="lineNum">     216 </span>            :     clear(memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="217"><span class="lineNum">     217 </span>            :     {</a>
<a name="218"><span class="lineNum">     218 </span>            :       memory_order __b = __m &amp; __memory_order_mask;</a>
<a name="219"><span class="lineNum">     219 </span>            :       __glibcxx_assert(__b != memory_order_consume);</a>
<a name="220"><span class="lineNum">     220 </span>            :       __glibcxx_assert(__b != memory_order_acquire);</a>
<a name="221"><span class="lineNum">     221 </span>            :       __glibcxx_assert(__b != memory_order_acq_rel);</a>
<a name="222"><span class="lineNum">     222 </span>            : </a>
<a name="223"><span class="lineNum">     223 </span>            :       __atomic_clear (&amp;_M_i, int(__m));</a>
<a name="224"><span class="lineNum">     224 </span>            :     }</a>
<a name="225"><span class="lineNum">     225 </span>            : </a>
<a name="226"><span class="lineNum">     226 </span>            :   private:</a>
<a name="227"><span class="lineNum">     227 </span>            :     static constexpr __atomic_flag_data_type</a>
<a name="228"><span class="lineNum">     228 </span>            :     _S_init(bool __i)</a>
<a name="229"><span class="lineNum">     229 </span>            :     { return __i ? __GCC_ATOMIC_TEST_AND_SET_TRUEVAL : 0; }</a>
<a name="230"><span class="lineNum">     230 </span>            :   };</a>
<a name="231"><span class="lineNum">     231 </span>            : </a>
<a name="232"><span class="lineNum">     232 </span>            : </a>
<a name="233"><span class="lineNum">     233 </span>            :   /// Base class for atomic integrals.</a>
<a name="234"><span class="lineNum">     234 </span>            :   //</a>
<a name="235"><span class="lineNum">     235 </span>            :   // For each of the integral types, define atomic_[integral type] struct</a>
<a name="236"><span class="lineNum">     236 </span>            :   //</a>
<a name="237"><span class="lineNum">     237 </span>            :   // atomic_bool     bool</a>
<a name="238"><span class="lineNum">     238 </span>            :   // atomic_char     char</a>
<a name="239"><span class="lineNum">     239 </span>            :   // atomic_schar    signed char</a>
<a name="240"><span class="lineNum">     240 </span>            :   // atomic_uchar    unsigned char</a>
<a name="241"><span class="lineNum">     241 </span>            :   // atomic_short    short</a>
<a name="242"><span class="lineNum">     242 </span>            :   // atomic_ushort   unsigned short</a>
<a name="243"><span class="lineNum">     243 </span>            :   // atomic_int      int</a>
<a name="244"><span class="lineNum">     244 </span>            :   // atomic_uint     unsigned int</a>
<a name="245"><span class="lineNum">     245 </span>            :   // atomic_long     long</a>
<a name="246"><span class="lineNum">     246 </span>            :   // atomic_ulong    unsigned long</a>
<a name="247"><span class="lineNum">     247 </span>            :   // atomic_llong    long long</a>
<a name="248"><span class="lineNum">     248 </span>            :   // atomic_ullong   unsigned long long</a>
<a name="249"><span class="lineNum">     249 </span>            :   // atomic_char8_t  char8_t</a>
<a name="250"><span class="lineNum">     250 </span>            :   // atomic_char16_t char16_t</a>
<a name="251"><span class="lineNum">     251 </span>            :   // atomic_char32_t char32_t</a>
<a name="252"><span class="lineNum">     252 </span>            :   // atomic_wchar_t  wchar_t</a>
<a name="253"><span class="lineNum">     253 </span>            :   //</a>
<a name="254"><span class="lineNum">     254 </span>            :   // NB: Assuming _ITp is an integral scalar type that is 1, 2, 4, or</a>
<a name="255"><span class="lineNum">     255 </span>            :   // 8 bytes, since that is what GCC built-in functions for atomic</a>
<a name="256"><span class="lineNum">     256 </span>            :   // memory access expect.</a>
<a name="257"><span class="lineNum">     257 </span>            :   template&lt;typename _ITp&gt;</a>
<a name="258"><span class="lineNum">     258 </span>            :     struct __atomic_base</a>
<a name="259"><span class="lineNum">     259 </span>            :     {</a>
<a name="260"><span class="lineNum">     260 </span>            :       using value_type = _ITp;</a>
<a name="261"><span class="lineNum">     261 </span>            :       using difference_type = value_type;</a>
<a name="262"><span class="lineNum">     262 </span>            : </a>
<a name="263"><span class="lineNum">     263 </span>            :     private:</a>
<a name="264"><span class="lineNum">     264 </span>            :       typedef _ITp      __int_type;</a>
<a name="265"><span class="lineNum">     265 </span>            : </a>
<a name="266"><span class="lineNum">     266 </span>            :       static constexpr int _S_alignment =</a>
<a name="267"><span class="lineNum">     267 </span>            :         sizeof(_ITp) &gt; alignof(_ITp) ? sizeof(_ITp) : alignof(_ITp);</a>
<a name="268"><span class="lineNum">     268 </span>            : </a>
<a name="269"><span class="lineNum">     269 </span>            :       alignas(_S_alignment) __int_type _M_i;</a>
<a name="270"><span class="lineNum">     270 </span>            : </a>
<a name="271"><span class="lineNum">     271 </span>            :     public:</a>
<a name="272"><span class="lineNum">     272 </span>            :       __atomic_base() noexcept = default;</a>
<a name="273"><span class="lineNum">     273 </span>            :       ~__atomic_base() noexcept = default;</a>
<a name="274"><span class="lineNum">     274 </span>            :       __atomic_base(const __atomic_base&amp;) = delete;</a>
<a name="275"><span class="lineNum">     275 </span>            :       __atomic_base&amp; operator=(const __atomic_base&amp;) = delete;</a>
<a name="276"><span class="lineNum">     276 </span>            :       __atomic_base&amp; operator=(const __atomic_base&amp;) volatile = delete;</a>
<a name="277"><span class="lineNum">     277 </span>            : </a>
<a name="278"><span class="lineNum">     278 </span>            :       // Requires __int_type convertible to _M_i.</a>
<a name="279"><span class="lineNum">     279 </span><span class="lineCov">          2 :       constexpr __atomic_base(__int_type __i) noexcept : _M_i (__i) { }</span></a>
<a name="280"><span class="lineNum">     280 </span>            : </a>
<a name="281"><span class="lineNum">     281 </span>            :       operator __int_type() const noexcept</a>
<a name="282"><span class="lineNum">     282 </span>            :       { return load(); }</a>
<a name="283"><span class="lineNum">     283 </span>            : </a>
<a name="284"><span class="lineNum">     284 </span>            :       operator __int_type() const volatile noexcept</a>
<a name="285"><span class="lineNum">     285 </span>            :       { return load(); }</a>
<a name="286"><span class="lineNum">     286 </span>            : </a>
<a name="287"><span class="lineNum">     287 </span>            :       __int_type</a>
<a name="288"><span class="lineNum">     288 </span>            :       operator=(__int_type __i) noexcept</a>
<a name="289"><span class="lineNum">     289 </span>            :       {</a>
<a name="290"><span class="lineNum">     290 </span>            :         store(__i);</a>
<a name="291"><span class="lineNum">     291 </span>            :         return __i;</a>
<a name="292"><span class="lineNum">     292 </span>            :       }</a>
<a name="293"><span class="lineNum">     293 </span>            : </a>
<a name="294"><span class="lineNum">     294 </span>            :       __int_type</a>
<a name="295"><span class="lineNum">     295 </span>            :       operator=(__int_type __i) volatile noexcept</a>
<a name="296"><span class="lineNum">     296 </span>            :       {</a>
<a name="297"><span class="lineNum">     297 </span>            :         store(__i);</a>
<a name="298"><span class="lineNum">     298 </span>            :         return __i;</a>
<a name="299"><span class="lineNum">     299 </span>            :       }</a>
<a name="300"><span class="lineNum">     300 </span>            : </a>
<a name="301"><span class="lineNum">     301 </span>            :       __int_type</a>
<a name="302"><span class="lineNum">     302 </span>            :       operator++(int) noexcept</a>
<a name="303"><span class="lineNum">     303 </span>            :       { return fetch_add(1); }</a>
<a name="304"><span class="lineNum">     304 </span>            : </a>
<a name="305"><span class="lineNum">     305 </span>            :       __int_type</a>
<a name="306"><span class="lineNum">     306 </span>            :       operator++(int) volatile noexcept</a>
<a name="307"><span class="lineNum">     307 </span>            :       { return fetch_add(1); }</a>
<a name="308"><span class="lineNum">     308 </span>            : </a>
<a name="309"><span class="lineNum">     309 </span>            :       __int_type</a>
<a name="310"><span class="lineNum">     310 </span>            :       operator--(int) noexcept</a>
<a name="311"><span class="lineNum">     311 </span>            :       { return fetch_sub(1); }</a>
<a name="312"><span class="lineNum">     312 </span>            : </a>
<a name="313"><span class="lineNum">     313 </span>            :       __int_type</a>
<a name="314"><span class="lineNum">     314 </span>            :       operator--(int) volatile noexcept</a>
<a name="315"><span class="lineNum">     315 </span>            :       { return fetch_sub(1); }</a>
<a name="316"><span class="lineNum">     316 </span>            : </a>
<a name="317"><span class="lineNum">     317 </span>            :       __int_type</a>
<a name="318"><span class="lineNum">     318 </span><span class="lineCov">         10 :       operator++() noexcept</span></a>
<a name="319"><span class="lineNum">     319 </span><span class="lineCov">         10 :       { return __atomic_add_fetch(&amp;_M_i, 1, int(memory_order_seq_cst)); }</span></a>
<a name="320"><span class="lineNum">     320 </span>            : </a>
<a name="321"><span class="lineNum">     321 </span>            :       __int_type</a>
<a name="322"><span class="lineNum">     322 </span>            :       operator++() volatile noexcept</a>
<a name="323"><span class="lineNum">     323 </span>            :       { return __atomic_add_fetch(&amp;_M_i, 1, int(memory_order_seq_cst)); }</a>
<a name="324"><span class="lineNum">     324 </span>            : </a>
<a name="325"><span class="lineNum">     325 </span>            :       __int_type</a>
<a name="326"><span class="lineNum">     326 </span><span class="lineCov">        269 :       operator--() noexcept</span></a>
<a name="327"><span class="lineNum">     327 </span><span class="lineCov">        269 :       { return __atomic_sub_fetch(&amp;_M_i, 1, int(memory_order_seq_cst)); }</span></a>
<a name="328"><span class="lineNum">     328 </span>            : </a>
<a name="329"><span class="lineNum">     329 </span>            :       __int_type</a>
<a name="330"><span class="lineNum">     330 </span>            :       operator--() volatile noexcept</a>
<a name="331"><span class="lineNum">     331 </span>            :       { return __atomic_sub_fetch(&amp;_M_i, 1, int(memory_order_seq_cst)); }</a>
<a name="332"><span class="lineNum">     332 </span>            : </a>
<a name="333"><span class="lineNum">     333 </span>            :       __int_type</a>
<a name="334"><span class="lineNum">     334 </span>            :       operator+=(__int_type __i) noexcept</a>
<a name="335"><span class="lineNum">     335 </span>            :       { return __atomic_add_fetch(&amp;_M_i, __i, int(memory_order_seq_cst)); }</a>
<a name="336"><span class="lineNum">     336 </span>            : </a>
<a name="337"><span class="lineNum">     337 </span>            :       __int_type</a>
<a name="338"><span class="lineNum">     338 </span>            :       operator+=(__int_type __i) volatile noexcept</a>
<a name="339"><span class="lineNum">     339 </span>            :       { return __atomic_add_fetch(&amp;_M_i, __i, int(memory_order_seq_cst)); }</a>
<a name="340"><span class="lineNum">     340 </span>            : </a>
<a name="341"><span class="lineNum">     341 </span>            :       __int_type</a>
<a name="342"><span class="lineNum">     342 </span>            :       operator-=(__int_type __i) noexcept</a>
<a name="343"><span class="lineNum">     343 </span>            :       { return __atomic_sub_fetch(&amp;_M_i, __i, int(memory_order_seq_cst)); }</a>
<a name="344"><span class="lineNum">     344 </span>            : </a>
<a name="345"><span class="lineNum">     345 </span>            :       __int_type</a>
<a name="346"><span class="lineNum">     346 </span>            :       operator-=(__int_type __i) volatile noexcept</a>
<a name="347"><span class="lineNum">     347 </span>            :       { return __atomic_sub_fetch(&amp;_M_i, __i, int(memory_order_seq_cst)); }</a>
<a name="348"><span class="lineNum">     348 </span>            : </a>
<a name="349"><span class="lineNum">     349 </span>            :       __int_type</a>
<a name="350"><span class="lineNum">     350 </span>            :       operator&amp;=(__int_type __i) noexcept</a>
<a name="351"><span class="lineNum">     351 </span>            :       { return __atomic_and_fetch(&amp;_M_i, __i, int(memory_order_seq_cst)); }</a>
<a name="352"><span class="lineNum">     352 </span>            : </a>
<a name="353"><span class="lineNum">     353 </span>            :       __int_type</a>
<a name="354"><span class="lineNum">     354 </span>            :       operator&amp;=(__int_type __i) volatile noexcept</a>
<a name="355"><span class="lineNum">     355 </span>            :       { return __atomic_and_fetch(&amp;_M_i, __i, int(memory_order_seq_cst)); }</a>
<a name="356"><span class="lineNum">     356 </span>            : </a>
<a name="357"><span class="lineNum">     357 </span>            :       __int_type</a>
<a name="358"><span class="lineNum">     358 </span>            :       operator|=(__int_type __i) noexcept</a>
<a name="359"><span class="lineNum">     359 </span>            :       { return __atomic_or_fetch(&amp;_M_i, __i, int(memory_order_seq_cst)); }</a>
<a name="360"><span class="lineNum">     360 </span>            : </a>
<a name="361"><span class="lineNum">     361 </span>            :       __int_type</a>
<a name="362"><span class="lineNum">     362 </span>            :       operator|=(__int_type __i) volatile noexcept</a>
<a name="363"><span class="lineNum">     363 </span>            :       { return __atomic_or_fetch(&amp;_M_i, __i, int(memory_order_seq_cst)); }</a>
<a name="364"><span class="lineNum">     364 </span>            : </a>
<a name="365"><span class="lineNum">     365 </span>            :       __int_type</a>
<a name="366"><span class="lineNum">     366 </span>            :       operator^=(__int_type __i) noexcept</a>
<a name="367"><span class="lineNum">     367 </span>            :       { return __atomic_xor_fetch(&amp;_M_i, __i, int(memory_order_seq_cst)); }</a>
<a name="368"><span class="lineNum">     368 </span>            : </a>
<a name="369"><span class="lineNum">     369 </span>            :       __int_type</a>
<a name="370"><span class="lineNum">     370 </span>            :       operator^=(__int_type __i) volatile noexcept</a>
<a name="371"><span class="lineNum">     371 </span>            :       { return __atomic_xor_fetch(&amp;_M_i, __i, int(memory_order_seq_cst)); }</a>
<a name="372"><span class="lineNum">     372 </span>            : </a>
<a name="373"><span class="lineNum">     373 </span>            :       bool</a>
<a name="374"><span class="lineNum">     374 </span>            :       is_lock_free() const noexcept</a>
<a name="375"><span class="lineNum">     375 </span>            :       {</a>
<a name="376"><span class="lineNum">     376 </span>            :         // Use a fake, minimally aligned pointer.</a>
<a name="377"><span class="lineNum">     377 </span>            :         return __atomic_is_lock_free(sizeof(_M_i),</a>
<a name="378"><span class="lineNum">     378 </span>            :             reinterpret_cast&lt;void *&gt;(-_S_alignment));</a>
<a name="379"><span class="lineNum">     379 </span>            :       }</a>
<a name="380"><span class="lineNum">     380 </span>            : </a>
<a name="381"><span class="lineNum">     381 </span>            :       bool</a>
<a name="382"><span class="lineNum">     382 </span>            :       is_lock_free() const volatile noexcept</a>
<a name="383"><span class="lineNum">     383 </span>            :       {</a>
<a name="384"><span class="lineNum">     384 </span>            :         // Use a fake, minimally aligned pointer.</a>
<a name="385"><span class="lineNum">     385 </span>            :         return __atomic_is_lock_free(sizeof(_M_i),</a>
<a name="386"><span class="lineNum">     386 </span>            :             reinterpret_cast&lt;void *&gt;(-_S_alignment));</a>
<a name="387"><span class="lineNum">     387 </span>            :       }</a>
<a name="388"><span class="lineNum">     388 </span>            : </a>
<a name="389"><span class="lineNum">     389 </span>            :       _GLIBCXX_ALWAYS_INLINE void</a>
<a name="390"><span class="lineNum">     390 </span>            :       store(__int_type __i, memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="391"><span class="lineNum">     391 </span>            :       {</a>
<a name="392"><span class="lineNum">     392 </span>            :         memory_order __b = __m &amp; __memory_order_mask;</a>
<a name="393"><span class="lineNum">     393 </span>            :         __glibcxx_assert(__b != memory_order_acquire);</a>
<a name="394"><span class="lineNum">     394 </span>            :         __glibcxx_assert(__b != memory_order_acq_rel);</a>
<a name="395"><span class="lineNum">     395 </span>            :         __glibcxx_assert(__b != memory_order_consume);</a>
<a name="396"><span class="lineNum">     396 </span>            : </a>
<a name="397"><span class="lineNum">     397 </span>            :         __atomic_store_n(&amp;_M_i, __i, int(__m));</a>
<a name="398"><span class="lineNum">     398 </span>            :       }</a>
<a name="399"><span class="lineNum">     399 </span>            : </a>
<a name="400"><span class="lineNum">     400 </span>            :       _GLIBCXX_ALWAYS_INLINE void</a>
<a name="401"><span class="lineNum">     401 </span>            :       store(__int_type __i,</a>
<a name="402"><span class="lineNum">     402 </span>            :             memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="403"><span class="lineNum">     403 </span>            :       {</a>
<a name="404"><span class="lineNum">     404 </span>            :         memory_order __b = __m &amp; __memory_order_mask;</a>
<a name="405"><span class="lineNum">     405 </span>            :         __glibcxx_assert(__b != memory_order_acquire);</a>
<a name="406"><span class="lineNum">     406 </span>            :         __glibcxx_assert(__b != memory_order_acq_rel);</a>
<a name="407"><span class="lineNum">     407 </span>            :         __glibcxx_assert(__b != memory_order_consume);</a>
<a name="408"><span class="lineNum">     408 </span>            : </a>
<a name="409"><span class="lineNum">     409 </span>            :         __atomic_store_n(&amp;_M_i, __i, int(__m));</a>
<a name="410"><span class="lineNum">     410 </span>            :       }</a>
<a name="411"><span class="lineNum">     411 </span>            : </a>
<a name="412"><span class="lineNum">     412 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="413"><span class="lineNum">     413 </span>            :       load(memory_order __m = memory_order_seq_cst) const noexcept</a>
<a name="414"><span class="lineNum">     414 </span>            :       {</a>
<a name="415"><span class="lineNum">     415 </span><span class="lineCov">      74176 :         memory_order __b = __m &amp; __memory_order_mask;</span></a>
<a name="416"><span class="lineNum">     416 </span>            :         __glibcxx_assert(__b != memory_order_release);</a>
<a name="417"><span class="lineNum">     417 </span>            :         __glibcxx_assert(__b != memory_order_acq_rel);</a>
<a name="418"><span class="lineNum">     418 </span>            : </a>
<a name="419"><span class="lineNum">     419 </span><span class="lineCov">      74176 :         return __atomic_load_n(&amp;_M_i, int(__m));</span></a>
<a name="420"><span class="lineNum">     420 </span>            :       }</a>
<a name="421"><span class="lineNum">     421 </span>            : </a>
<a name="422"><span class="lineNum">     422 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="423"><span class="lineNum">     423 </span>            :       load(memory_order __m = memory_order_seq_cst) const volatile noexcept</a>
<a name="424"><span class="lineNum">     424 </span>            :       {</a>
<a name="425"><span class="lineNum">     425 </span>            :         memory_order __b = __m &amp; __memory_order_mask;</a>
<a name="426"><span class="lineNum">     426 </span>            :         __glibcxx_assert(__b != memory_order_release);</a>
<a name="427"><span class="lineNum">     427 </span>            :         __glibcxx_assert(__b != memory_order_acq_rel);</a>
<a name="428"><span class="lineNum">     428 </span>            : </a>
<a name="429"><span class="lineNum">     429 </span>            :         return __atomic_load_n(&amp;_M_i, int(__m));</a>
<a name="430"><span class="lineNum">     430 </span>            :       }</a>
<a name="431"><span class="lineNum">     431 </span>            : </a>
<a name="432"><span class="lineNum">     432 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="433"><span class="lineNum">     433 </span>            :       exchange(__int_type __i,</a>
<a name="434"><span class="lineNum">     434 </span>            :                memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="435"><span class="lineNum">     435 </span>            :       {</a>
<a name="436"><span class="lineNum">     436 </span>            :         return __atomic_exchange_n(&amp;_M_i, __i, int(__m));</a>
<a name="437"><span class="lineNum">     437 </span>            :       }</a>
<a name="438"><span class="lineNum">     438 </span>            : </a>
<a name="439"><span class="lineNum">     439 </span>            : </a>
<a name="440"><span class="lineNum">     440 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="441"><span class="lineNum">     441 </span>            :       exchange(__int_type __i,</a>
<a name="442"><span class="lineNum">     442 </span>            :                memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="443"><span class="lineNum">     443 </span>            :       {</a>
<a name="444"><span class="lineNum">     444 </span>            :         return __atomic_exchange_n(&amp;_M_i, __i, int(__m));</a>
<a name="445"><span class="lineNum">     445 </span>            :       }</a>
<a name="446"><span class="lineNum">     446 </span>            : </a>
<a name="447"><span class="lineNum">     447 </span>            :       _GLIBCXX_ALWAYS_INLINE bool</a>
<a name="448"><span class="lineNum">     448 </span>            :       compare_exchange_weak(__int_type&amp; __i1, __int_type __i2,</a>
<a name="449"><span class="lineNum">     449 </span>            :                             memory_order __m1, memory_order __m2) noexcept</a>
<a name="450"><span class="lineNum">     450 </span>            :       {</a>
<a name="451"><span class="lineNum">     451 </span>            :         memory_order __b2 = __m2 &amp; __memory_order_mask;</a>
<a name="452"><span class="lineNum">     452 </span>            :         memory_order __b1 = __m1 &amp; __memory_order_mask;</a>
<a name="453"><span class="lineNum">     453 </span>            :         __glibcxx_assert(__b2 != memory_order_release);</a>
<a name="454"><span class="lineNum">     454 </span>            :         __glibcxx_assert(__b2 != memory_order_acq_rel);</a>
<a name="455"><span class="lineNum">     455 </span>            :         __glibcxx_assert(__b2 &lt;= __b1);</a>
<a name="456"><span class="lineNum">     456 </span>            : </a>
<a name="457"><span class="lineNum">     457 </span>            :         return __atomic_compare_exchange_n(&amp;_M_i, &amp;__i1, __i2, 1,</a>
<a name="458"><span class="lineNum">     458 </span>            :                                            int(__m1), int(__m2));</a>
<a name="459"><span class="lineNum">     459 </span>            :       }</a>
<a name="460"><span class="lineNum">     460 </span>            : </a>
<a name="461"><span class="lineNum">     461 </span>            :       _GLIBCXX_ALWAYS_INLINE bool</a>
<a name="462"><span class="lineNum">     462 </span>            :       compare_exchange_weak(__int_type&amp; __i1, __int_type __i2,</a>
<a name="463"><span class="lineNum">     463 </span>            :                             memory_order __m1,</a>
<a name="464"><span class="lineNum">     464 </span>            :                             memory_order __m2) volatile noexcept</a>
<a name="465"><span class="lineNum">     465 </span>            :       {</a>
<a name="466"><span class="lineNum">     466 </span>            :         memory_order __b2 = __m2 &amp; __memory_order_mask;</a>
<a name="467"><span class="lineNum">     467 </span>            :         memory_order __b1 = __m1 &amp; __memory_order_mask;</a>
<a name="468"><span class="lineNum">     468 </span>            :         __glibcxx_assert(__b2 != memory_order_release);</a>
<a name="469"><span class="lineNum">     469 </span>            :         __glibcxx_assert(__b2 != memory_order_acq_rel);</a>
<a name="470"><span class="lineNum">     470 </span>            :         __glibcxx_assert(__b2 &lt;= __b1);</a>
<a name="471"><span class="lineNum">     471 </span>            : </a>
<a name="472"><span class="lineNum">     472 </span>            :         return __atomic_compare_exchange_n(&amp;_M_i, &amp;__i1, __i2, 1,</a>
<a name="473"><span class="lineNum">     473 </span>            :                                            int(__m1), int(__m2));</a>
<a name="474"><span class="lineNum">     474 </span>            :       }</a>
<a name="475"><span class="lineNum">     475 </span>            : </a>
<a name="476"><span class="lineNum">     476 </span>            :       _GLIBCXX_ALWAYS_INLINE bool</a>
<a name="477"><span class="lineNum">     477 </span>            :       compare_exchange_weak(__int_type&amp; __i1, __int_type __i2,</a>
<a name="478"><span class="lineNum">     478 </span>            :                             memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="479"><span class="lineNum">     479 </span>            :       {</a>
<a name="480"><span class="lineNum">     480 </span>            :         return compare_exchange_weak(__i1, __i2, __m,</a>
<a name="481"><span class="lineNum">     481 </span>            :                                      __cmpexch_failure_order(__m));</a>
<a name="482"><span class="lineNum">     482 </span>            :       }</a>
<a name="483"><span class="lineNum">     483 </span>            : </a>
<a name="484"><span class="lineNum">     484 </span>            :       _GLIBCXX_ALWAYS_INLINE bool</a>
<a name="485"><span class="lineNum">     485 </span>            :       compare_exchange_weak(__int_type&amp; __i1, __int_type __i2,</a>
<a name="486"><span class="lineNum">     486 </span>            :                    memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="487"><span class="lineNum">     487 </span>            :       {</a>
<a name="488"><span class="lineNum">     488 </span>            :         return compare_exchange_weak(__i1, __i2, __m,</a>
<a name="489"><span class="lineNum">     489 </span>            :                                      __cmpexch_failure_order(__m));</a>
<a name="490"><span class="lineNum">     490 </span>            :       }</a>
<a name="491"><span class="lineNum">     491 </span>            : </a>
<a name="492"><span class="lineNum">     492 </span>            :       _GLIBCXX_ALWAYS_INLINE bool</a>
<a name="493"><span class="lineNum">     493 </span>            :       compare_exchange_strong(__int_type&amp; __i1, __int_type __i2,</a>
<a name="494"><span class="lineNum">     494 </span>            :                               memory_order __m1, memory_order __m2) noexcept</a>
<a name="495"><span class="lineNum">     495 </span>            :       {</a>
<a name="496"><span class="lineNum">     496 </span>            :         memory_order __b2 = __m2 &amp; __memory_order_mask;</a>
<a name="497"><span class="lineNum">     497 </span>            :         memory_order __b1 = __m1 &amp; __memory_order_mask;</a>
<a name="498"><span class="lineNum">     498 </span>            :         __glibcxx_assert(__b2 != memory_order_release);</a>
<a name="499"><span class="lineNum">     499 </span>            :         __glibcxx_assert(__b2 != memory_order_acq_rel);</a>
<a name="500"><span class="lineNum">     500 </span>            :         __glibcxx_assert(__b2 &lt;= __b1);</a>
<a name="501"><span class="lineNum">     501 </span>            : </a>
<a name="502"><span class="lineNum">     502 </span>            :         return __atomic_compare_exchange_n(&amp;_M_i, &amp;__i1, __i2, 0,</a>
<a name="503"><span class="lineNum">     503 </span>            :                                            int(__m1), int(__m2));</a>
<a name="504"><span class="lineNum">     504 </span>            :       }</a>
<a name="505"><span class="lineNum">     505 </span>            : </a>
<a name="506"><span class="lineNum">     506 </span>            :       _GLIBCXX_ALWAYS_INLINE bool</a>
<a name="507"><span class="lineNum">     507 </span>            :       compare_exchange_strong(__int_type&amp; __i1, __int_type __i2,</a>
<a name="508"><span class="lineNum">     508 </span>            :                               memory_order __m1,</a>
<a name="509"><span class="lineNum">     509 </span>            :                               memory_order __m2) volatile noexcept</a>
<a name="510"><span class="lineNum">     510 </span>            :       {</a>
<a name="511"><span class="lineNum">     511 </span>            :         memory_order __b2 = __m2 &amp; __memory_order_mask;</a>
<a name="512"><span class="lineNum">     512 </span>            :         memory_order __b1 = __m1 &amp; __memory_order_mask;</a>
<a name="513"><span class="lineNum">     513 </span>            : </a>
<a name="514"><span class="lineNum">     514 </span>            :         __glibcxx_assert(__b2 != memory_order_release);</a>
<a name="515"><span class="lineNum">     515 </span>            :         __glibcxx_assert(__b2 != memory_order_acq_rel);</a>
<a name="516"><span class="lineNum">     516 </span>            :         __glibcxx_assert(__b2 &lt;= __b1);</a>
<a name="517"><span class="lineNum">     517 </span>            : </a>
<a name="518"><span class="lineNum">     518 </span>            :         return __atomic_compare_exchange_n(&amp;_M_i, &amp;__i1, __i2, 0,</a>
<a name="519"><span class="lineNum">     519 </span>            :                                            int(__m1), int(__m2));</a>
<a name="520"><span class="lineNum">     520 </span>            :       }</a>
<a name="521"><span class="lineNum">     521 </span>            : </a>
<a name="522"><span class="lineNum">     522 </span>            :       _GLIBCXX_ALWAYS_INLINE bool</a>
<a name="523"><span class="lineNum">     523 </span>            :       compare_exchange_strong(__int_type&amp; __i1, __int_type __i2,</a>
<a name="524"><span class="lineNum">     524 </span>            :                               memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="525"><span class="lineNum">     525 </span>            :       {</a>
<a name="526"><span class="lineNum">     526 </span>            :         return compare_exchange_strong(__i1, __i2, __m,</a>
<a name="527"><span class="lineNum">     527 </span>            :                                        __cmpexch_failure_order(__m));</a>
<a name="528"><span class="lineNum">     528 </span>            :       }</a>
<a name="529"><span class="lineNum">     529 </span>            : </a>
<a name="530"><span class="lineNum">     530 </span>            :       _GLIBCXX_ALWAYS_INLINE bool</a>
<a name="531"><span class="lineNum">     531 </span>            :       compare_exchange_strong(__int_type&amp; __i1, __int_type __i2,</a>
<a name="532"><span class="lineNum">     532 </span>            :                  memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="533"><span class="lineNum">     533 </span>            :       {</a>
<a name="534"><span class="lineNum">     534 </span>            :         return compare_exchange_strong(__i1, __i2, __m,</a>
<a name="535"><span class="lineNum">     535 </span>            :                                        __cmpexch_failure_order(__m));</a>
<a name="536"><span class="lineNum">     536 </span>            :       }</a>
<a name="537"><span class="lineNum">     537 </span>            : </a>
<a name="538"><span class="lineNum">     538 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="539"><span class="lineNum">     539 </span>            :       fetch_add(__int_type __i,</a>
<a name="540"><span class="lineNum">     540 </span>            :                 memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="541"><span class="lineNum">     541 </span>            :       { return __atomic_fetch_add(&amp;_M_i, __i, int(__m)); }</a>
<a name="542"><span class="lineNum">     542 </span>            : </a>
<a name="543"><span class="lineNum">     543 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="544"><span class="lineNum">     544 </span>            :       fetch_add(__int_type __i,</a>
<a name="545"><span class="lineNum">     545 </span>            :                 memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="546"><span class="lineNum">     546 </span>            :       { return __atomic_fetch_add(&amp;_M_i, __i, int(__m)); }</a>
<a name="547"><span class="lineNum">     547 </span>            : </a>
<a name="548"><span class="lineNum">     548 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="549"><span class="lineNum">     549 </span>            :       fetch_sub(__int_type __i,</a>
<a name="550"><span class="lineNum">     550 </span>            :                 memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="551"><span class="lineNum">     551 </span>            :       { return __atomic_fetch_sub(&amp;_M_i, __i, int(__m)); }</a>
<a name="552"><span class="lineNum">     552 </span>            : </a>
<a name="553"><span class="lineNum">     553 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="554"><span class="lineNum">     554 </span>            :       fetch_sub(__int_type __i,</a>
<a name="555"><span class="lineNum">     555 </span>            :                 memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="556"><span class="lineNum">     556 </span>            :       { return __atomic_fetch_sub(&amp;_M_i, __i, int(__m)); }</a>
<a name="557"><span class="lineNum">     557 </span>            : </a>
<a name="558"><span class="lineNum">     558 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="559"><span class="lineNum">     559 </span>            :       fetch_and(__int_type __i,</a>
<a name="560"><span class="lineNum">     560 </span>            :                 memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="561"><span class="lineNum">     561 </span>            :       { return __atomic_fetch_and(&amp;_M_i, __i, int(__m)); }</a>
<a name="562"><span class="lineNum">     562 </span>            : </a>
<a name="563"><span class="lineNum">     563 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="564"><span class="lineNum">     564 </span>            :       fetch_and(__int_type __i,</a>
<a name="565"><span class="lineNum">     565 </span>            :                 memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="566"><span class="lineNum">     566 </span>            :       { return __atomic_fetch_and(&amp;_M_i, __i, int(__m)); }</a>
<a name="567"><span class="lineNum">     567 </span>            : </a>
<a name="568"><span class="lineNum">     568 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="569"><span class="lineNum">     569 </span>            :       fetch_or(__int_type __i,</a>
<a name="570"><span class="lineNum">     570 </span>            :                memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="571"><span class="lineNum">     571 </span>            :       { return __atomic_fetch_or(&amp;_M_i, __i, int(__m)); }</a>
<a name="572"><span class="lineNum">     572 </span>            : </a>
<a name="573"><span class="lineNum">     573 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="574"><span class="lineNum">     574 </span>            :       fetch_or(__int_type __i,</a>
<a name="575"><span class="lineNum">     575 </span>            :                memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="576"><span class="lineNum">     576 </span>            :       { return __atomic_fetch_or(&amp;_M_i, __i, int(__m)); }</a>
<a name="577"><span class="lineNum">     577 </span>            : </a>
<a name="578"><span class="lineNum">     578 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="579"><span class="lineNum">     579 </span>            :       fetch_xor(__int_type __i,</a>
<a name="580"><span class="lineNum">     580 </span>            :                 memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="581"><span class="lineNum">     581 </span>            :       { return __atomic_fetch_xor(&amp;_M_i, __i, int(__m)); }</a>
<a name="582"><span class="lineNum">     582 </span>            : </a>
<a name="583"><span class="lineNum">     583 </span>            :       _GLIBCXX_ALWAYS_INLINE __int_type</a>
<a name="584"><span class="lineNum">     584 </span>            :       fetch_xor(__int_type __i,</a>
<a name="585"><span class="lineNum">     585 </span>            :                 memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="586"><span class="lineNum">     586 </span>            :       { return __atomic_fetch_xor(&amp;_M_i, __i, int(__m)); }</a>
<a name="587"><span class="lineNum">     587 </span>            :     };</a>
<a name="588"><span class="lineNum">     588 </span>            : </a>
<a name="589"><span class="lineNum">     589 </span>            : </a>
<a name="590"><span class="lineNum">     590 </span>            :   /// Partial specialization for pointer types.</a>
<a name="591"><span class="lineNum">     591 </span>            :   template&lt;typename _PTp&gt;</a>
<a name="592"><span class="lineNum">     592 </span>            :     struct __atomic_base&lt;_PTp*&gt;</a>
<a name="593"><span class="lineNum">     593 </span>            :     {</a>
<a name="594"><span class="lineNum">     594 </span>            :     private:</a>
<a name="595"><span class="lineNum">     595 </span>            :       typedef _PTp*     __pointer_type;</a>
<a name="596"><span class="lineNum">     596 </span>            : </a>
<a name="597"><span class="lineNum">     597 </span>            :       __pointer_type    _M_p;</a>
<a name="598"><span class="lineNum">     598 </span>            : </a>
<a name="599"><span class="lineNum">     599 </span>            :       // Factored out to facilitate explicit specialization.</a>
<a name="600"><span class="lineNum">     600 </span>            :       constexpr ptrdiff_t</a>
<a name="601"><span class="lineNum">     601 </span>            :       _M_type_size(ptrdiff_t __d) const { return __d * sizeof(_PTp); }</a>
<a name="602"><span class="lineNum">     602 </span>            : </a>
<a name="603"><span class="lineNum">     603 </span>            :       constexpr ptrdiff_t</a>
<a name="604"><span class="lineNum">     604 </span>            :       _M_type_size(ptrdiff_t __d) const volatile { return __d * sizeof(_PTp); }</a>
<a name="605"><span class="lineNum">     605 </span>            : </a>
<a name="606"><span class="lineNum">     606 </span>            :     public:</a>
<a name="607"><span class="lineNum">     607 </span>            :       __atomic_base() noexcept = default;</a>
<a name="608"><span class="lineNum">     608 </span>            :       ~__atomic_base() noexcept = default;</a>
<a name="609"><span class="lineNum">     609 </span>            :       __atomic_base(const __atomic_base&amp;) = delete;</a>
<a name="610"><span class="lineNum">     610 </span>            :       __atomic_base&amp; operator=(const __atomic_base&amp;) = delete;</a>
<a name="611"><span class="lineNum">     611 </span>            :       __atomic_base&amp; operator=(const __atomic_base&amp;) volatile = delete;</a>
<a name="612"><span class="lineNum">     612 </span>            : </a>
<a name="613"><span class="lineNum">     613 </span>            :       // Requires __pointer_type convertible to _M_p.</a>
<a name="614"><span class="lineNum">     614 </span>            :       constexpr __atomic_base(__pointer_type __p) noexcept : _M_p (__p) { }</a>
<a name="615"><span class="lineNum">     615 </span>            : </a>
<a name="616"><span class="lineNum">     616 </span>            :       operator __pointer_type() const noexcept</a>
<a name="617"><span class="lineNum">     617 </span>            :       { return load(); }</a>
<a name="618"><span class="lineNum">     618 </span>            : </a>
<a name="619"><span class="lineNum">     619 </span>            :       operator __pointer_type() const volatile noexcept</a>
<a name="620"><span class="lineNum">     620 </span>            :       { return load(); }</a>
<a name="621"><span class="lineNum">     621 </span>            : </a>
<a name="622"><span class="lineNum">     622 </span>            :       __pointer_type</a>
<a name="623"><span class="lineNum">     623 </span>            :       operator=(__pointer_type __p) noexcept</a>
<a name="624"><span class="lineNum">     624 </span>            :       {</a>
<a name="625"><span class="lineNum">     625 </span>            :         store(__p);</a>
<a name="626"><span class="lineNum">     626 </span>            :         return __p;</a>
<a name="627"><span class="lineNum">     627 </span>            :       }</a>
<a name="628"><span class="lineNum">     628 </span>            : </a>
<a name="629"><span class="lineNum">     629 </span>            :       __pointer_type</a>
<a name="630"><span class="lineNum">     630 </span>            :       operator=(__pointer_type __p) volatile noexcept</a>
<a name="631"><span class="lineNum">     631 </span>            :       {</a>
<a name="632"><span class="lineNum">     632 </span>            :         store(__p);</a>
<a name="633"><span class="lineNum">     633 </span>            :         return __p;</a>
<a name="634"><span class="lineNum">     634 </span>            :       }</a>
<a name="635"><span class="lineNum">     635 </span>            : </a>
<a name="636"><span class="lineNum">     636 </span>            :       __pointer_type</a>
<a name="637"><span class="lineNum">     637 </span>            :       operator++(int) noexcept</a>
<a name="638"><span class="lineNum">     638 </span>            :       { return fetch_add(1); }</a>
<a name="639"><span class="lineNum">     639 </span>            : </a>
<a name="640"><span class="lineNum">     640 </span>            :       __pointer_type</a>
<a name="641"><span class="lineNum">     641 </span>            :       operator++(int) volatile noexcept</a>
<a name="642"><span class="lineNum">     642 </span>            :       { return fetch_add(1); }</a>
<a name="643"><span class="lineNum">     643 </span>            : </a>
<a name="644"><span class="lineNum">     644 </span>            :       __pointer_type</a>
<a name="645"><span class="lineNum">     645 </span>            :       operator--(int) noexcept</a>
<a name="646"><span class="lineNum">     646 </span>            :       { return fetch_sub(1); }</a>
<a name="647"><span class="lineNum">     647 </span>            : </a>
<a name="648"><span class="lineNum">     648 </span>            :       __pointer_type</a>
<a name="649"><span class="lineNum">     649 </span>            :       operator--(int) volatile noexcept</a>
<a name="650"><span class="lineNum">     650 </span>            :       { return fetch_sub(1); }</a>
<a name="651"><span class="lineNum">     651 </span>            : </a>
<a name="652"><span class="lineNum">     652 </span>            :       __pointer_type</a>
<a name="653"><span class="lineNum">     653 </span>            :       operator++() noexcept</a>
<a name="654"><span class="lineNum">     654 </span>            :       { return __atomic_add_fetch(&amp;_M_p, _M_type_size(1),</a>
<a name="655"><span class="lineNum">     655 </span>            :                                   int(memory_order_seq_cst)); }</a>
<a name="656"><span class="lineNum">     656 </span>            : </a>
<a name="657"><span class="lineNum">     657 </span>            :       __pointer_type</a>
<a name="658"><span class="lineNum">     658 </span>            :       operator++() volatile noexcept</a>
<a name="659"><span class="lineNum">     659 </span>            :       { return __atomic_add_fetch(&amp;_M_p, _M_type_size(1),</a>
<a name="660"><span class="lineNum">     660 </span>            :                                   int(memory_order_seq_cst)); }</a>
<a name="661"><span class="lineNum">     661 </span>            : </a>
<a name="662"><span class="lineNum">     662 </span>            :       __pointer_type</a>
<a name="663"><span class="lineNum">     663 </span>            :       operator--() noexcept</a>
<a name="664"><span class="lineNum">     664 </span>            :       { return __atomic_sub_fetch(&amp;_M_p, _M_type_size(1),</a>
<a name="665"><span class="lineNum">     665 </span>            :                                   int(memory_order_seq_cst)); }</a>
<a name="666"><span class="lineNum">     666 </span>            : </a>
<a name="667"><span class="lineNum">     667 </span>            :       __pointer_type</a>
<a name="668"><span class="lineNum">     668 </span>            :       operator--() volatile noexcept</a>
<a name="669"><span class="lineNum">     669 </span>            :       { return __atomic_sub_fetch(&amp;_M_p, _M_type_size(1),</a>
<a name="670"><span class="lineNum">     670 </span>            :                                   int(memory_order_seq_cst)); }</a>
<a name="671"><span class="lineNum">     671 </span>            : </a>
<a name="672"><span class="lineNum">     672 </span>            :       __pointer_type</a>
<a name="673"><span class="lineNum">     673 </span>            :       operator+=(ptrdiff_t __d) noexcept</a>
<a name="674"><span class="lineNum">     674 </span>            :       { return __atomic_add_fetch(&amp;_M_p, _M_type_size(__d),</a>
<a name="675"><span class="lineNum">     675 </span>            :                                   int(memory_order_seq_cst)); }</a>
<a name="676"><span class="lineNum">     676 </span>            : </a>
<a name="677"><span class="lineNum">     677 </span>            :       __pointer_type</a>
<a name="678"><span class="lineNum">     678 </span>            :       operator+=(ptrdiff_t __d) volatile noexcept</a>
<a name="679"><span class="lineNum">     679 </span>            :       { return __atomic_add_fetch(&amp;_M_p, _M_type_size(__d),</a>
<a name="680"><span class="lineNum">     680 </span>            :                                   int(memory_order_seq_cst)); }</a>
<a name="681"><span class="lineNum">     681 </span>            : </a>
<a name="682"><span class="lineNum">     682 </span>            :       __pointer_type</a>
<a name="683"><span class="lineNum">     683 </span>            :       operator-=(ptrdiff_t __d) noexcept</a>
<a name="684"><span class="lineNum">     684 </span>            :       { return __atomic_sub_fetch(&amp;_M_p, _M_type_size(__d),</a>
<a name="685"><span class="lineNum">     685 </span>            :                                   int(memory_order_seq_cst)); }</a>
<a name="686"><span class="lineNum">     686 </span>            : </a>
<a name="687"><span class="lineNum">     687 </span>            :       __pointer_type</a>
<a name="688"><span class="lineNum">     688 </span>            :       operator-=(ptrdiff_t __d) volatile noexcept</a>
<a name="689"><span class="lineNum">     689 </span>            :       { return __atomic_sub_fetch(&amp;_M_p, _M_type_size(__d),</a>
<a name="690"><span class="lineNum">     690 </span>            :                                   int(memory_order_seq_cst)); }</a>
<a name="691"><span class="lineNum">     691 </span>            : </a>
<a name="692"><span class="lineNum">     692 </span>            :       bool</a>
<a name="693"><span class="lineNum">     693 </span>            :       is_lock_free() const noexcept</a>
<a name="694"><span class="lineNum">     694 </span>            :       {</a>
<a name="695"><span class="lineNum">     695 </span>            :         // Produce a fake, minimally aligned pointer.</a>
<a name="696"><span class="lineNum">     696 </span>            :         return __atomic_is_lock_free(sizeof(_M_p),</a>
<a name="697"><span class="lineNum">     697 </span>            :             reinterpret_cast&lt;void *&gt;(-__alignof(_M_p)));</a>
<a name="698"><span class="lineNum">     698 </span>            :       }</a>
<a name="699"><span class="lineNum">     699 </span>            : </a>
<a name="700"><span class="lineNum">     700 </span>            :       bool</a>
<a name="701"><span class="lineNum">     701 </span>            :       is_lock_free() const volatile noexcept</a>
<a name="702"><span class="lineNum">     702 </span>            :       {</a>
<a name="703"><span class="lineNum">     703 </span>            :         // Produce a fake, minimally aligned pointer.</a>
<a name="704"><span class="lineNum">     704 </span>            :         return __atomic_is_lock_free(sizeof(_M_p),</a>
<a name="705"><span class="lineNum">     705 </span>            :             reinterpret_cast&lt;void *&gt;(-__alignof(_M_p)));</a>
<a name="706"><span class="lineNum">     706 </span>            :       }</a>
<a name="707"><span class="lineNum">     707 </span>            : </a>
<a name="708"><span class="lineNum">     708 </span>            :       _GLIBCXX_ALWAYS_INLINE void</a>
<a name="709"><span class="lineNum">     709 </span>            :       store(__pointer_type __p,</a>
<a name="710"><span class="lineNum">     710 </span>            :             memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="711"><span class="lineNum">     711 </span>            :       {</a>
<a name="712"><span class="lineNum">     712 </span>            :         memory_order __b = __m &amp; __memory_order_mask;</a>
<a name="713"><span class="lineNum">     713 </span>            : </a>
<a name="714"><span class="lineNum">     714 </span>            :         __glibcxx_assert(__b != memory_order_acquire);</a>
<a name="715"><span class="lineNum">     715 </span>            :         __glibcxx_assert(__b != memory_order_acq_rel);</a>
<a name="716"><span class="lineNum">     716 </span>            :         __glibcxx_assert(__b != memory_order_consume);</a>
<a name="717"><span class="lineNum">     717 </span>            : </a>
<a name="718"><span class="lineNum">     718 </span>            :         __atomic_store_n(&amp;_M_p, __p, int(__m));</a>
<a name="719"><span class="lineNum">     719 </span>            :       }</a>
<a name="720"><span class="lineNum">     720 </span>            : </a>
<a name="721"><span class="lineNum">     721 </span>            :       _GLIBCXX_ALWAYS_INLINE void</a>
<a name="722"><span class="lineNum">     722 </span>            :       store(__pointer_type __p,</a>
<a name="723"><span class="lineNum">     723 </span>            :             memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="724"><span class="lineNum">     724 </span>            :       {</a>
<a name="725"><span class="lineNum">     725 </span>            :         memory_order __b = __m &amp; __memory_order_mask;</a>
<a name="726"><span class="lineNum">     726 </span>            :         __glibcxx_assert(__b != memory_order_acquire);</a>
<a name="727"><span class="lineNum">     727 </span>            :         __glibcxx_assert(__b != memory_order_acq_rel);</a>
<a name="728"><span class="lineNum">     728 </span>            :         __glibcxx_assert(__b != memory_order_consume);</a>
<a name="729"><span class="lineNum">     729 </span>            : </a>
<a name="730"><span class="lineNum">     730 </span>            :         __atomic_store_n(&amp;_M_p, __p, int(__m));</a>
<a name="731"><span class="lineNum">     731 </span>            :       }</a>
<a name="732"><span class="lineNum">     732 </span>            : </a>
<a name="733"><span class="lineNum">     733 </span>            :       _GLIBCXX_ALWAYS_INLINE __pointer_type</a>
<a name="734"><span class="lineNum">     734 </span>            :       load(memory_order __m = memory_order_seq_cst) const noexcept</a>
<a name="735"><span class="lineNum">     735 </span>            :       {</a>
<a name="736"><span class="lineNum">     736 </span>            :         memory_order __b = __m &amp; __memory_order_mask;</a>
<a name="737"><span class="lineNum">     737 </span>            :         __glibcxx_assert(__b != memory_order_release);</a>
<a name="738"><span class="lineNum">     738 </span>            :         __glibcxx_assert(__b != memory_order_acq_rel);</a>
<a name="739"><span class="lineNum">     739 </span>            : </a>
<a name="740"><span class="lineNum">     740 </span>            :         return __atomic_load_n(&amp;_M_p, int(__m));</a>
<a name="741"><span class="lineNum">     741 </span>            :       }</a>
<a name="742"><span class="lineNum">     742 </span>            : </a>
<a name="743"><span class="lineNum">     743 </span>            :       _GLIBCXX_ALWAYS_INLINE __pointer_type</a>
<a name="744"><span class="lineNum">     744 </span>            :       load(memory_order __m = memory_order_seq_cst) const volatile noexcept</a>
<a name="745"><span class="lineNum">     745 </span>            :       {</a>
<a name="746"><span class="lineNum">     746 </span>            :         memory_order __b = __m &amp; __memory_order_mask;</a>
<a name="747"><span class="lineNum">     747 </span>            :         __glibcxx_assert(__b != memory_order_release);</a>
<a name="748"><span class="lineNum">     748 </span>            :         __glibcxx_assert(__b != memory_order_acq_rel);</a>
<a name="749"><span class="lineNum">     749 </span>            : </a>
<a name="750"><span class="lineNum">     750 </span>            :         return __atomic_load_n(&amp;_M_p, int(__m));</a>
<a name="751"><span class="lineNum">     751 </span>            :       }</a>
<a name="752"><span class="lineNum">     752 </span>            : </a>
<a name="753"><span class="lineNum">     753 </span>            :       _GLIBCXX_ALWAYS_INLINE __pointer_type</a>
<a name="754"><span class="lineNum">     754 </span>            :       exchange(__pointer_type __p,</a>
<a name="755"><span class="lineNum">     755 </span>            :                memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="756"><span class="lineNum">     756 </span>            :       {</a>
<a name="757"><span class="lineNum">     757 </span>            :         return __atomic_exchange_n(&amp;_M_p, __p, int(__m));</a>
<a name="758"><span class="lineNum">     758 </span>            :       }</a>
<a name="759"><span class="lineNum">     759 </span>            : </a>
<a name="760"><span class="lineNum">     760 </span>            : </a>
<a name="761"><span class="lineNum">     761 </span>            :       _GLIBCXX_ALWAYS_INLINE __pointer_type</a>
<a name="762"><span class="lineNum">     762 </span>            :       exchange(__pointer_type __p,</a>
<a name="763"><span class="lineNum">     763 </span>            :                memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="764"><span class="lineNum">     764 </span>            :       {</a>
<a name="765"><span class="lineNum">     765 </span>            :         return __atomic_exchange_n(&amp;_M_p, __p, int(__m));</a>
<a name="766"><span class="lineNum">     766 </span>            :       }</a>
<a name="767"><span class="lineNum">     767 </span>            : </a>
<a name="768"><span class="lineNum">     768 </span>            :       _GLIBCXX_ALWAYS_INLINE bool</a>
<a name="769"><span class="lineNum">     769 </span>            :       compare_exchange_strong(__pointer_type&amp; __p1, __pointer_type __p2,</a>
<a name="770"><span class="lineNum">     770 </span>            :                               memory_order __m1,</a>
<a name="771"><span class="lineNum">     771 </span>            :                               memory_order __m2) noexcept</a>
<a name="772"><span class="lineNum">     772 </span>            :       {</a>
<a name="773"><span class="lineNum">     773 </span>            :         memory_order __b2 = __m2 &amp; __memory_order_mask;</a>
<a name="774"><span class="lineNum">     774 </span>            :         memory_order __b1 = __m1 &amp; __memory_order_mask;</a>
<a name="775"><span class="lineNum">     775 </span>            :         __glibcxx_assert(__b2 != memory_order_release);</a>
<a name="776"><span class="lineNum">     776 </span>            :         __glibcxx_assert(__b2 != memory_order_acq_rel);</a>
<a name="777"><span class="lineNum">     777 </span>            :         __glibcxx_assert(__b2 &lt;= __b1);</a>
<a name="778"><span class="lineNum">     778 </span>            : </a>
<a name="779"><span class="lineNum">     779 </span>            :         return __atomic_compare_exchange_n(&amp;_M_p, &amp;__p1, __p2, 0,</a>
<a name="780"><span class="lineNum">     780 </span>            :                                            int(__m1), int(__m2));</a>
<a name="781"><span class="lineNum">     781 </span>            :       }</a>
<a name="782"><span class="lineNum">     782 </span>            : </a>
<a name="783"><span class="lineNum">     783 </span>            :       _GLIBCXX_ALWAYS_INLINE bool</a>
<a name="784"><span class="lineNum">     784 </span>            :       compare_exchange_strong(__pointer_type&amp; __p1, __pointer_type __p2,</a>
<a name="785"><span class="lineNum">     785 </span>            :                               memory_order __m1,</a>
<a name="786"><span class="lineNum">     786 </span>            :                               memory_order __m2) volatile noexcept</a>
<a name="787"><span class="lineNum">     787 </span>            :       {</a>
<a name="788"><span class="lineNum">     788 </span>            :         memory_order __b2 = __m2 &amp; __memory_order_mask;</a>
<a name="789"><span class="lineNum">     789 </span>            :         memory_order __b1 = __m1 &amp; __memory_order_mask;</a>
<a name="790"><span class="lineNum">     790 </span>            : </a>
<a name="791"><span class="lineNum">     791 </span>            :         __glibcxx_assert(__b2 != memory_order_release);</a>
<a name="792"><span class="lineNum">     792 </span>            :         __glibcxx_assert(__b2 != memory_order_acq_rel);</a>
<a name="793"><span class="lineNum">     793 </span>            :         __glibcxx_assert(__b2 &lt;= __b1);</a>
<a name="794"><span class="lineNum">     794 </span>            : </a>
<a name="795"><span class="lineNum">     795 </span>            :         return __atomic_compare_exchange_n(&amp;_M_p, &amp;__p1, __p2, 0,</a>
<a name="796"><span class="lineNum">     796 </span>            :                                            int(__m1), int(__m2));</a>
<a name="797"><span class="lineNum">     797 </span>            :       }</a>
<a name="798"><span class="lineNum">     798 </span>            : </a>
<a name="799"><span class="lineNum">     799 </span>            :       _GLIBCXX_ALWAYS_INLINE __pointer_type</a>
<a name="800"><span class="lineNum">     800 </span>            :       fetch_add(ptrdiff_t __d,</a>
<a name="801"><span class="lineNum">     801 </span>            :                 memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="802"><span class="lineNum">     802 </span>            :       { return __atomic_fetch_add(&amp;_M_p, _M_type_size(__d), int(__m)); }</a>
<a name="803"><span class="lineNum">     803 </span>            : </a>
<a name="804"><span class="lineNum">     804 </span>            :       _GLIBCXX_ALWAYS_INLINE __pointer_type</a>
<a name="805"><span class="lineNum">     805 </span>            :       fetch_add(ptrdiff_t __d,</a>
<a name="806"><span class="lineNum">     806 </span>            :                 memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="807"><span class="lineNum">     807 </span>            :       { return __atomic_fetch_add(&amp;_M_p, _M_type_size(__d), int(__m)); }</a>
<a name="808"><span class="lineNum">     808 </span>            : </a>
<a name="809"><span class="lineNum">     809 </span>            :       _GLIBCXX_ALWAYS_INLINE __pointer_type</a>
<a name="810"><span class="lineNum">     810 </span>            :       fetch_sub(ptrdiff_t __d,</a>
<a name="811"><span class="lineNum">     811 </span>            :                 memory_order __m = memory_order_seq_cst) noexcept</a>
<a name="812"><span class="lineNum">     812 </span>            :       { return __atomic_fetch_sub(&amp;_M_p, _M_type_size(__d), int(__m)); }</a>
<a name="813"><span class="lineNum">     813 </span>            : </a>
<a name="814"><span class="lineNum">     814 </span>            :       _GLIBCXX_ALWAYS_INLINE __pointer_type</a>
<a name="815"><span class="lineNum">     815 </span>            :       fetch_sub(ptrdiff_t __d,</a>
<a name="816"><span class="lineNum">     816 </span>            :                 memory_order __m = memory_order_seq_cst) volatile noexcept</a>
<a name="817"><span class="lineNum">     817 </span>            :       { return __atomic_fetch_sub(&amp;_M_p, _M_type_size(__d), int(__m)); }</a>
<a name="818"><span class="lineNum">     818 </span>            :     };</a>
<a name="819"><span class="lineNum">     819 </span>            : </a>
<a name="820"><span class="lineNum">     820 </span>            :   // @} group atomics</a>
<a name="821"><span class="lineNum">     821 </span>            : </a>
<a name="822"><span class="lineNum">     822 </span>            : _GLIBCXX_END_NAMESPACE_VERSION</a>
<a name="823"><span class="lineNum">     823 </span>            : } // namespace std</a>
<a name="824"><span class="lineNum">     824 </span>            : </a>
<a name="825"><span class="lineNum">     825 </span>            : #endif</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../../../../../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
